/*
    A0չ棬ʹ2λĴ74HC595D24λܣеһ595COMڣڶ595LED
    15 14 13 12 11 10 09 08 07 06 05 04 03 02 01 00
    0  1  2  3  4  5  6  7  A  B  C  D  E  F  G  H
    ܣCOMΪ͵ƽLEDΪߵƽһ()ʾ1
    MSBģʽ Ҫ 0000 0110 1111 1110 = 0x06fe
    LSBģʽ Ҫ 0111 1111 0110 0000 = 0x7f60
*/

#include "Hardware/SEG/seg.h"

#define sequence    MSB     // 74HC595Dֽڷģʽ: MSBģʽͣλȷ͡LSBģʽͣλȷ͡

//------------------------------  ------------------------------
// 
const u8 SEG_font[39] =
{
    0x3f, /* 00 "0" */
    0x06, /* 01 "1" */
    0x5b, /* 02 "2" */
    0x4f, /* 03 "3" */
    0x66, /* 04 "4" */
    0x6d, /* 05 "5" */
    0x7d, /* 06 "6" */
    0x07, /* 07 "7" */
    0x7f, /* 08 "8" */
    0x6f, /* 09 "9" */
    0x77, /* 10 "A" */
    0x7c, /* 11 "B" */
    0x39, /* 12 "C" */
    0x5e, /* 13 "D" */
    0x79, /* 14 "E" */
    0x71, /* 15 "F" */
    0x3d, /* 16 "G" */
    0x76, /* 17 "H" */
    0x30, /* 18 "I" */
    0x0e, /* 19 "J" */
    0x7a, /* 20 "K" */
    0x38, /* 21 "L" */
    0x55, /* 22 "M" */
    0x54, /* 23 "N" */
    0x5c, /* 24 "O" */
    0x73, /* 25 "P" */
    0x67, /* 26 "Q" */
    0x50, /* 27 "R" */
    0x64, /* 28 "S" */
    0x78, /* 29 "T" */
    0x3e, /* 30 "U" */
    0x62, /* 31 "V" */
    0x6a, /* 32 "W" */
    0x36, /* 33 "X" */
    0x6e, /* 34 "Y" */
    0x49, /* 35 "Z" */
    0x40, /* 36 "-" */
    0x00, /* 37 " " */
    0x80, /* 38 "." */
};

const u8 SEG_com[8] = {SEG0, SEG1, SEG2, SEG3, SEG4, SEG5, SEG6, SEG7};
//------------------------------  ------------------------------

/**
 * @name 74HC595D_SendByte
 * @brief λĴһֽ
 * @param dat: Ҫ͵8bit
 * @return 
 * @version 汾v1.0
 * @date ڣ2025-04-13
 * @author ߣϫ
 * @note עͣ
 */
void HC595D_SendByte(u8 dat)
{
    u8 i;

    for ( i = 0; i < 8; i++)
    {
        HC595_SH = 0;   // ʱ
        #if sequence == MSB
        HC595_DS = dat & 0x80;  // MSB 
        dat = _crol_(dat, 1);   // MSB һλ
        #elif sequence == LSB
        HC595_DS = dat & 0x01;  // LSB 
        dat = _cror_(dat, 1);   // LSB һλ
        #endif
        HC595_SH = 1;   // ʱߣλ

    }
}

/**
 * @name HC595_SendNByte
 * @brief N74HC595D
 * @param arr: ׵ַ 
 * @param num: 595
 * @return 
 * @version 汾v1.0
 * @date ڣ2025-04-13
 * @author ߣϫ
 * @note עͣ
 */
void HC595_SendNByte(u8 *arr, u8 num)
{
    u8 i;

    HC595_ST = 0;   // ʹ洢ʱ
    for ( i = 0; i < num; i++)
    {
        HC595D_SendByte(arr[i]);
    }
    HC595_ST = 1;   // д8bitݣʱ߽ݱ浽595
}

/**
 * @name SEG_Show_ChDat
 * @brief ӦʾӦ
 * @param com: λ
 * @param com: ܶ
 * @version 汾v1.0
 * @date ڣ2025-04-13
 * @author ߣϫ
 * @note עͣʹùܣMSBģʽȷ룬ٷλ
 */
void SEG_Show_ComDat(u8 com, u8 dat)
{
    HC595_ST = 0;   // ʹ洢ʱ
    HC595D_SendByte(dat);
    HC595D_SendByte(com);
    HC595_ST = 1;   // д8bitݣʱ߽ݱ浽595
}

/**
 * @name SMG_Show_Num
 * @brief һλʾһ
 * @param ch : λ
 * @param num: 
 * @param dot: ǷʾС
 * @version 汾v1.0
 * @date ڣ2025-04-19
 * @author ߣϫ
 * @note עͣʾ 0-9 ʾ -
 */
void SMG_Show_Num(u8 ch, u8 num, u8 dot)
{
    if ( (0 <= num) && (num <= 9))
    {
        if(dot)
            SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[num] | 0x80));
        else
            SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[num]));
    }
    else
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[36]));
}

/**
 * @name SEG_Show_Chr
 * @brief һλʾһַ
 * @param ch : λ
 * @param chr: ַ
 * @param dot: ǷʾС
 * @version 汾v1.0
 * @date ڣ2025-04-13
 * @author ߣϫ
 * @note עͣʾ 0-9, 26ĸ(Сдһ), ո, ʾһ
 */
void SEG_Show_Chr(u8 ch, u8 chr, bit dot)
{
    if ( ('0' <= chr) && (chr <= '9'))
    {
        if(dot)
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[chr - '0'] | 0x80));
        else
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[chr - '0']));
    }
    else if ( ('a' <= chr) && (chr <= 'z'))
    {
        if(dot)
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[chr - 'a' + 10] | 0x80));
        else
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[chr - 'a' + 10]));
    }
    else if ( ('A' <= chr) && (chr <= 'Z'))
    {
        if(dot)
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[chr - 'A' + 10] | 0x80));
        else
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[chr - 'A' + 10]));
    }
    else if ( chr == ' ')
    {
        if(dot)
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[37] | 0x80));
        else
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[37]));
    }
    else
    {
        if(dot)
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[36] | 0x80));
        else
        SEG_Show_ComDat((u8)(ch), (u8)(SEG_font[36]));
    }
}

/**
 * @name SEG_Show_Str
 * @brief ʾһַӵ1ܿʼʾǰ8λ
 * @param str: ַ
 * @version 汾v1.0
 * @date ڣ2025-04-13
 * @author ߣϫ
 * @note עͣ sprintf ʹ
 */
void SEG_Show_Str(char *str)
{
    u8 i = 0, j = 0;
    while (str[i] != '\0')      //ȡַ֮ǰһֱѭ
    {
        if (str[i+1]=='.')
        {
            SEG_Show_Chr(SEG_com[j], str[i], 1);
            i++;
        }
        else
            SEG_Show_Chr(SEG_com[j], str[i], 0);
        j++;
        i++;            //ָƵһַ
        if (j > 7)  return; // ʾ8λ
    }
}







































